/*
 * Copyright (c) 2005 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.imode;

import java.util.List;

import jp.sourceforge.livez.CarrierType;
import jp.sourceforge.livez.MobilePhone;
import jp.sourceforge.livez.Screen;
import jp.sourceforge.livez.ServiceType;

/**
 * i[h[̃C^[tF[XłB
 * 
 * @author V _
 */
public interface Imode extends MobilePhone<ImodeBrowser, Iappli, UID> {

	// ---------------------------------------- ÓI

	/**
	 * [̒񋟂ʐMT[rX̎ނԂ܂B<p>
	 *  "i[h" Ԃ܂B
	 * 
	 * @return "i[h" \ʐMT[rX̎
	 */
	public ServiceType getServiceType();

	/**
	 * LA̎ނԂ܂B<p>
	 *  "NTThR" Ԃ܂B
	 * 
	 * @return "NTThR" \LA̎
	 */
	public CarrierType getCarrierType();

	/**
	 * HTTP[UG[WFg̋@햼Ԃ܂B<p>
	 */
	public String getId();

	/**
	 * @햼Ԃ܂B<p>
	 * 
	 * @return @햼
	 */
	public String getName();

	/**
	 * iԂ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return i
	 */
	public String getProductName();

	/**
	 * V[YԂ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return V[Y
	 */
	public String getSeriesName();

	/**
	 * x_[IDԂ܂B<p>
	 * x_[ID͒[̑Oɕt^Ă鐻[J[\ZłB<br>
	 * i[hΉJ[ir PlayStation ̏ꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return x_[ID
	 */
	public String getVendorId();

	/**
	 * ʏԂ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return ʏ
	 */
	public Screen getScreen();

	/**
	 * wʉʏԂ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * Ή󋵂ƐF/KɂĂ̓T|[gĂ܂B
	 * 
	 * @return ʏ
	 */
	public SubScreen getSubScreen();

	/**
	 * i[huEUԂ܂B<p>
	 * 
	 * @return i[huEU
	 */
	public ImodeBrowser getBrowser();

	/**
	 * iAvsԂ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return iAvs
	 */
	public Iappli getAppli();

	/**
	 * Flash Lite ΉԂ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return Flash Lite Ή
	 */
	public Flash getFlash();

	/**
	 * i[VΉԂ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return i[VΉ
	 */
	public ImotionType getImotionType();

	/**
	 * PDFΉ󋵂Ԃ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>false</code> Ԃ܂B
	 * 
	 * @return PDFΉ
	 */
	public boolean isPdf();

	/**
	 * LdΉ󋵂Ԃ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>false</code> Ԃ܂B
	 * 
	 * @return LdΉ
	 */
	public boolean isCharaDen();

	/**
	 * fR[ΉԂ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return fR[Ή
	 */
	public Decomail getDecomail();

	/**
	 * gJΉ󋵂Ԃ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>false</code> Ԃ܂B
	 * 
	 * @return gJΉ
	 */
	public boolean isToruca();

	/**
	 * i`lΉ󋵂Ԃ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>false</code> Ԃ܂B
	 * 
	 * @return i`lΉ
	 */
	public boolean isIchannel();

	/**
	 * i[hΉG̎ނԂ܂B
	 * 
	 * @return i[hΉG̎
	 */
	public IemojiType getIemojiType();

	/**
	 * ʐ^t[摜Ή̃XgԂ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return ʐ^t[摜Ή̃Xg
	 */
	public List<Frame> getFrames();

	/**
	 * j[ACRΉ󋵂Ԃ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>false</code> Ԃ܂B
	 * 
	 * @return j[ACRΉ
	 */
	public boolean isMenuIcon();

	/**
	 * o[R[hΉo[WԂ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return o[R[hΉo[W
	 */
	public Float getBarcode();

	/**
	 * SSL ΉxԂ܂B<p>
	 * Ή̏ꍇsȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return SSLΉx
	 */
	public Integer getSsl();



	// ---------------------------------------- I

	/**
	 * ANZX̒[^CvԂ܂B<p>
	 * mova [ł̓ANZXɏԂω\鎖ɒӂĉB
	 * 
	 * @return [^Cv
	 */
	public ImodeType getType();

	/**
	 * ʐMԃR[hԂ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return ʐMԃR[h
	 */
	public AccessType getAccessType();

	/**
	 * ʐM̎ނԂ܂B<p>
	 * ł N900iL ȊO̒[ł͕K "i[hʐM" Ԃ܂B
	 * 
	 * @return ʐM̎
	 */
	public NetworkType getNetworkType();

	/**
	 * [UANZXĂ鍑ԍԂ܂B<p>
	 * {̃ANZX̏ꍇ -1 Ԃ܂B
	 * 
	 * @return ԍ
	 * @see <a href="http://www.itu.int/itudoc/itu-t/ob-lists/icc/e212_685.html">List of Mobile Country or Geographical Area Codes</a>
	 */
	public int getGeoCode();

	/**
	 * ԍԂ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return ԍ
	 */
	public String getSer();

	/**
	 * FOMAJ[hʔԍԂ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return FOMAJ[hʔԍ
	 */
	public String getIcc();

	/**
	 * TCg̏ꍇ́AUID Ԃ܂B<p>
	 * TCg(TCg)̏ꍇ͏ <code>null</code> Ԃ܂B
	 * 
	 * @return UID 
	 */
	public UID getUserId();

	/**
	 * gXebhAPID Ԃ܂B<p>
	 * sȏꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return gXebhAPID
	 */
	public String getTrustedId();

}
