package jp.sourceforge.livez.dao.hibernate;

import java.util.List;

import jp.sourceforge.livez.dao.Imode;
import jp.sourceforge.livez.dao.ImodeDAO;
import jp.sourceforge.livez.dao.ImodeIappli;

public class ImodeDaoMySqlTest extends BaseMySQLTestCase {

	public void testLoad() {
		final ImodeDAO dao = (ImodeDAO) factory.getBean("imodeDao");

		// ꗗ
/*
		List<Imode> list = dao.loadAll();
		for (int i = 0; i < list.size(); i++) {
			Imode imode = list.get(i);
			System.out.println(imode.toString());
		}
*/

		// 쐬
		Imode imode = new Imode();
		imode.setName("ZZZZ");
		imode.setSeriesName("900i");
		imode.setHtml(new Float(1.0));
		imode.setBrowserWidth(100);
		imode.setBrowserHeight(100);
		imode.setMonochrome(false);
		imode.setColor(256);
		imode.setJpeg(true);
		imode.setPdf(true);
		imode.setCharaDen(true);
		imode.setToruca(true);
		imode.setIchannel(true);
		imode.setMenuIcon(true);

		ImodeIappli iappli = new ImodeIappli();
		iappli.setName("ZZZZ");
		iappli.setDoja(new Float(1.0));
		iappli.setEdition(false);
		iappli.setJar(30);
		iappli.setSp(100);
		iappli.setWidth(50);
		iappli.setHeight(60);

		imode.setIappli(iappli);

		dao.save(imode);
		// SELECT
//		Imode imode = dao.load("N900iS");
//		System.out.println(imode.toString());

		// XV
		imode.setHtml(new Float(6.0));
		dao.update(imode, "ZZZZ");

		// 폜
		// DELETE
//		dao.delete("ZZZZ");
	}

}
